libzypp: zyppng::detail::StateWithTransitions< State, Transitions > Struct Template Reference

libzypp 17.36.6

Public Types | Public Member Functions | Public Attributes | Static Public Attributes | Private Attributes | List of all members
zyppng::detail::StateWithTransitions< State, Transitions > Struct Template Reference

`#include <zypp-core/zyppng/base/statemachine.h>`

## Public Types
using | StateType = State

## Public Member Functions
template<typename StateMachine>
| StateWithTransitions (StateMachine &sm)
| StateWithTransitions (std::shared_ptr< State > &&s)
| StateWithTransitions (StateWithTransitions &&other)=default
StateWithTransitions & | operator= (StateWithTransitions &&other)=default
| StateWithTransitions (const StateWithTransitions &other)=delete
StateWithTransitions & | operator= (const StateWithTransitions &other)=delete
void | enter ()
void | exit ()
std::shared_ptr< State > | wrappedState ()
const std::shared_ptr< State > | wrappedState () const

## Public Attributes
Transitions | _transitions

## Static Public Attributes
static constexpr auto | stateId = State::stateId
static constexpr bool | isFinal = State::isFinal

## Private Attributes
std::shared_ptr< State > | _ptr

## Detailed Description

template<class State, class Transitions>
struct zyppng::detail::StateWithTransitions< State, Transitions >

Definition at line 39 of file statemachine.h.

## Member Typedef Documentation

## ◆ StateType

template<class State, class Transitions>

using zyppng::detail::StateWithTransitions< State, Transitions >::StateType = State

Definition at line 40 of file statemachine.h.

## Constructor & Destructor Documentation

## ◆ StateWithTransitions() [1/4]

template<class State, class Transitions>
template<typename StateMachine>

zyppng::detail::StateWithTransitions< State, Transitions >::StateWithTransitions | ( | StateMachine & | sm | ) |
| inline

Definition at line 44 of file statemachine.h.

## ◆ StateWithTransitions() [2/4]

template<class State, class Transitions>

zyppng::detail::StateWithTransitions< State, Transitions >::StateWithTransitions | ( | std::shared_ptr< State > && | s | ) |
| inline

Definition at line 45 of file statemachine.h.

## ◆ StateWithTransitions() [3/4]

template<class State, class Transitions>

zyppng::detail::StateWithTransitions< State, Transitions >::StateWithTransitions | ( | StateWithTransitions< State, Transitions > && | other | ) |
| default

## ◆ StateWithTransitions() [4/4]

template<class State, class Transitions>

zyppng::detail::StateWithTransitions< State, Transitions >::StateWithTransitions | ( | const StateWithTransitions< State, Transitions > & | other | ) |
| delete

## Member Function Documentation

## ◆ operator=() [1/2]

template<class State, class Transitions>

StateWithTransitions & zyppng::detail::StateWithTransitions< State, Transitions >::operator= | ( | StateWithTransitions< State, Transitions > && | other | ) |
| default

## ◆ operator=() [2/2]

template<class State, class Transitions>

StateWithTransitions & zyppng::detail::StateWithTransitions< State, Transitions >::operator= | ( | const StateWithTransitions< State, Transitions > & | other | ) |
| delete

## ◆ enter()

template<class State, class Transitions>

void zyppng::detail::StateWithTransitions< State, Transitions >::enter | ( |  | ) |
| inline

Definition at line 58 of file statemachine.h.

## ◆ exit()

template<class State, class Transitions>

void zyppng::detail::StateWithTransitions< State, Transitions >::exit | ( |  | ) |
| inline

Definition at line 64 of file statemachine.h.

## ◆ wrappedState() [1/2]

template<class State, class Transitions>

std::shared_ptr< State > zyppng::detail::StateWithTransitions< State, Transitions >::wrappedState | ( |  | ) |
| inline

Definition at line 70 of file statemachine.h.

## ◆ wrappedState() [2/2]

template<class State, class Transitions>

const std::shared_ptr< State > zyppng::detail::StateWithTransitions< State, Transitions >::wrappedState | ( |  | ) | const
| inline

Definition at line 74 of file statemachine.h.

## Member Data Documentation

## ◆ _transitions

template<class State, class Transitions>

Transitions zyppng::detail::StateWithTransitions< State, Transitions >::_transitions

Definition at line 41 of file statemachine.h.

## ◆ stateId

template<class State, class Transitions>

auto zyppng::detail::StateWithTransitions< State, Transitions >::stateId = State::stateId
| staticconstexpr

Definition at line 55 of file statemachine.h.

## ◆ isFinal

template<class State, class Transitions>

bool zyppng::detail::StateWithTransitions< State, Transitions >::isFinal = State::isFinal
| staticconstexpr

Definition at line 56 of file statemachine.h.

## ◆ _ptr

template<class State, class Transitions>

std::shared_ptr<State> zyppng::detail::StateWithTransitions< State, Transitions >::_ptr
| private

Definition at line 80 of file statemachine.h.

The documentation for this struct was generated from the following file:

- zypp-core/zyppng/base/statemachine.h